0e5a33e3a30bd3da6445e7be206d97f961cdcd5e
[arvados.git] / build / run-tests.sh
1 #!/bin/bash
2
3 . `dirname "$(readlink -f "$0")"`/libcloud-pin
4
5 COLUMNS=80
6 . `dirname "$(readlink -f "$0")"`/run-library.sh
7
8 read -rd "\000" helpmessage <<EOF
9 $(basename $0): Install and test Arvados components.
10
11 Exit non-zero if any tests fail.
12
13 Syntax:
14         $(basename $0) WORKSPACE=/path/to/arvados [options]
15
16 Options:
17
18 --skip FOO     Do not test the FOO component.
19 --only FOO     Do not test anything except the FOO component.
20 --temp DIR     Install components and dependencies under DIR instead of
21                making a new temporary directory. Implies --leave-temp.
22 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
23                Instead, show the path to give as --temp to reuse them in
24                subsequent invocations.
25 --repeat N     Repeat each install/test step until it succeeds N times.
26 --retry        Prompt to retry if an install or test suite fails.
27 --skip-install Do not run any install steps. Just run tests.
28                You should provide GOPATH, GEMHOME, and VENVDIR options
29                from a previous invocation if you use this option.
30 --only-install Run specific install step
31 --short        Skip (or scale down) some slow tests.
32 WORKSPACE=path Arvados source tree to test.
33 CONFIGSRC=path Dir with api server config files to copy into source tree.
34                (If none given, leave config files alone in source tree.)
35 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
36                Restrict apiserver tests to the given file
37 sdk/python_test="--test-suite test.test_keep_locator"
38                Restrict Python SDK tests to the given class
39 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
40                Restrict Workbench tests to the given file
41 services/arv-git-httpd_test="-check.vv"
42                Show all log messages, even when tests pass (also works
43                with services/keepstore_test etc.)
44 ARVADOS_DEBUG=1
45                Print more debug messages
46 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
47                *_test, and other examples shown above.
48
49 Assuming --skip-install is not given, all components are installed
50 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
51 test suites depend on other components being installed, and installing
52 everything tends to be quicker than debugging dependencies.
53
54 As a special concession to the current CI server config, CONFIGSRC
55 defaults to $HOME/arvados-api-server if that directory exists.
56
57 More information and background:
58
59 https://arvados.org/projects/arvados/wiki/Running_tests
60
61 Available tests:
62
63 apps/workbench (*)
64 apps/workbench_units (*)
65 apps/workbench_functionals (*)
66 apps/workbench_integration (*)
67 apps/workbench_benchmark
68 apps/workbench_profile
69 doc
70 services/api
71 services/arv-git-httpd
72 services/crunchstat
73 services/dockercleaner
74 services/fuse
75 services/keep-web
76 services/keepproxy
77 services/keepstore
78 services/keep-balance
79 services/login-sync
80 services/nodemanager
81 services/crunch-run
82 services/crunch-dispatch-local
83 services/crunch-dispatch-slurm
84 services/ws
85 sdk/cli
86 sdk/pam
87 sdk/python
88 sdk/ruby
89 sdk/go/arvados
90 sdk/go/arvadosclient
91 sdk/go/keepclient
92 sdk/go/httpserver
93 sdk/go/manifest
94 sdk/go/blockdigest
95 sdk/go/streamer
96 sdk/go/stats
97 sdk/go/crunchrunner
98 sdk/cwl
99 tools/crunchstat-summary
100 tools/keep-exercise
101 tools/keep-rsync
102 tools/keep-block-check
103
104 (*) apps/workbench is shorthand for apps/workbench_units +
105     apps/workbench_functionals + apps/workbench_integration
106
107 EOF
108
109 # First make sure to remove any ARVADOS_ variables from the calling
110 # environment that could interfere with the tests.
111 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
112
113 # Reset other variables that could affect our [tests'] behavior by
114 # accident.
115 GITDIR=
116 GOPATH=
117 VENVDIR=
118 VENV3DIR=
119 PYTHONPATH=
120 GEMHOME=
121 PERLINSTALLBASE=
122
123 short=
124 skip_install=
125 temp=
126 temp_preserve=
127
128 clear_temp() {
129     if [[ -z "$temp" ]]; then
130         # we didn't even get as far as making a temp dir
131         :
132     elif [[ -z "$temp_preserve" ]]; then
133         rm -rf "$temp"
134     else
135         echo "Leaving behind temp dirs in $temp"
136     fi
137 }
138
139 fatal() {
140     clear_temp
141     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
142     exit 1
143 }
144
145 exit_cleanly() {
146     trap - INT
147     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
148     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
149     stop_services
150     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
151     report_outcomes
152     clear_temp
153     exit ${#failures}
154 }
155
156 sanity_checks() {
157     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
158         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
159     echo Checking dependencies:
160     echo -n 'virtualenv: '
161     virtualenv --version \
162         || fatal "No virtualenv. Try: apt-get install virtualenv (on ubuntu: python-virtualenv)"
163     echo -n 'ruby: '
164     ruby -v \
165         || fatal "No ruby. Install >=2.1.9 (using rbenv, rvm, or source)"
166     echo -n 'bundler: '
167     bundle version \
168         || fatal "No bundler. Try: gem install bundler"
169     echo -n 'go: '
170     go version \
171         || fatal "No go binary. See http://golang.org/doc/install"
172     [[ $(go version) =~ go1.([0-9]+) ]] && [[ ${BASH_REMATCH[1]} -ge 7 ]] \
173         || fatal "Go >= 1.7 required. See http://golang.org/doc/install"
174     echo -n 'gcc: '
175     gcc --version | egrep ^gcc \
176         || fatal "No gcc. Try: apt-get install build-essential"
177     echo -n 'fuse.h: '
178     find /usr/include -wholename '*fuse/fuse.h' \
179         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
180     echo -n 'pyconfig.h: '
181     find /usr/include -name pyconfig.h | egrep --max-count=1 . \
182         || fatal "No pyconfig.h. Try: apt-get install python-dev"
183     echo -n 'nginx: '
184     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
185         || fatal "No nginx. Try: apt-get install nginx"
186     echo -n 'perl: '
187     perl -v | grep version \
188         || fatal "No perl. Try: apt-get install perl"
189     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
190         echo -n "perl $mod: "
191         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
192             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl libwww-perl"
193     done
194     echo -n 'gitolite: '
195     which gitolite \
196         || fatal "No gitolite. Try: apt-get install gitolite3"
197 }
198
199 rotate_logfile() {
200   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
201   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
202   if [[ -f "$1/$2" ]]; then
203     THEDATE=`date +%Y%m%d%H%M%S`
204     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
205     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
206   fi
207 }
208
209 declare -a failures
210 declare -A skip
211 declare -A testargs
212 skip[apps/workbench_profile]=1
213
214 while [[ -n "$1" ]]
215 do
216     arg="$1"; shift
217     case "$arg" in
218         --help)
219             echo >&2 "$helpmessage"
220             echo >&2
221             exit 1
222             ;;
223         --skip)
224             skip[$1]=1; shift
225             ;;
226         --only)
227             only="$1"; skip[$1]=""; shift
228             ;;
229         --short)
230             short=1
231             ;;
232         --skip-install)
233             skip_install=1
234             ;;
235         --only-install)
236             skip_install=1
237             only_install="$1"; shift
238             ;;
239         --temp)
240             temp="$1"; shift
241             temp_preserve=1
242             ;;
243         --leave-temp)
244             temp_preserve=1
245             ;;
246         --repeat)
247             repeat=$((${1}+0)); shift
248             ;;
249         --retry)
250             retry=1
251             ;;
252         *_test=*)
253             suite="${arg%%_test=*}"
254             args="${arg#*=}"
255             testargs["$suite"]="$args"
256             ;;
257         *=*)
258             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
259             ;;
260         *)
261             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
262             exit 1
263             ;;
264     esac
265 done
266
267 start_api() {
268     echo 'Starting API server...'
269     cd "$WORKSPACE" \
270         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
271         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
272         && export ARVADOS_TEST_API_INSTALLED="$$" \
273         && python sdk/python/tests/run_test_server.py start_ws \
274         && python sdk/python/tests/run_test_server.py start_nginx \
275         && (env | egrep ^ARVADOS)
276 }
277
278 start_nginx_proxy_services() {
279     echo 'Starting keepproxy, keep-web, ws, arv-git-httpd, and nginx ssl proxy...'
280     cd "$WORKSPACE" \
281         && python sdk/python/tests/run_test_server.py start_keep_proxy \
282         && python sdk/python/tests/run_test_server.py start_keep-web \
283         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
284         && python sdk/python/tests/run_test_server.py start_ws \
285         && python sdk/python/tests/run_test_server.py start_nginx \
286         && export ARVADOS_TEST_PROXY_SERVICES=1
287 }
288
289 stop_services() {
290     if [[ -n "$ARVADOS_TEST_PROXY_SERVICES" ]]; then
291         unset ARVADOS_TEST_PROXY_SERVICES
292         cd "$WORKSPACE" \
293             && python sdk/python/tests/run_test_server.py stop_nginx \
294             && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
295             && python sdk/python/tests/run_test_server.py stop_ws \
296             && python sdk/python/tests/run_test_server.py stop_keep-web \
297             && python sdk/python/tests/run_test_server.py stop_keep_proxy
298     fi
299     if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
300         unset ARVADOS_TEST_API_HOST
301         cd "$WORKSPACE" \
302             && python sdk/python/tests/run_test_server.py stop_nginx \
303             && python sdk/python/tests/run_test_server.py stop_ws \
304             && python sdk/python/tests/run_test_server.py stop
305     fi
306 }
307
308 interrupt() {
309     failures+=("($(basename $0) interrupted)")
310     exit_cleanly
311 }
312 trap interrupt INT
313
314 sanity_checks
315
316 echo "WORKSPACE=$WORKSPACE"
317
318 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
319     # Jenkins expects us to use this by default.
320     CONFIGSRC="$HOME/arvados-api-server"
321 fi
322
323 # Clean up .pyc files that may exist in the workspace
324 cd "$WORKSPACE"
325 find -name '*.pyc' -delete
326
327 if [[ -z "$temp" ]]; then
328     temp="$(mktemp -d)"
329 fi
330
331 # Set up temporary install dirs (unless existing dirs were supplied)
332 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE
333 do
334     if [[ -z "${!tmpdir}" ]]; then
335         eval "$tmpdir"="$temp/$tmpdir"
336     fi
337     if ! [[ -d "${!tmpdir}" ]]; then
338         mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
339     fi
340 done
341
342 setup_ruby_environment() {
343     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
344       source "$HOME/.rvm/scripts/rvm"
345       using_rvm=true
346     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
347       source "/usr/local/rvm/scripts/rvm"
348       using_rvm=true
349     else
350       using_rvm=false
351     fi
352
353     if [[ "$using_rvm" == true ]]; then
354         # If rvm is in use, we can't just put separate "dependencies"
355         # and "gems-under-test" paths to GEM_PATH: passenger resets
356         # the environment to the "current gemset", which would lose
357         # our GEM_PATH and prevent our test suites from running ruby
358         # programs (for example, the Workbench test suite could not
359         # boot an API server or run arv). Instead, we have to make an
360         # rvm gemset and use it for everything.
361
362         [[ `type rvm | head -n1` == "rvm is a function" ]] \
363             || fatal 'rvm check'
364
365         # Put rvm's favorite path back in first place (overriding
366         # virtualenv, which just put itself there). Ignore rvm's
367         # complaint about not being in first place already.
368         rvm use @default 2>/dev/null
369
370         # Create (if needed) and switch to an @arvados-tests-* gemset,
371         # salting the gemset name so it doesn't interfere with
372         # concurrent builds in other workspaces. Leave the choice of
373         # ruby to the caller.
374         gemset="arvados-tests-$(echo -n "${WORKSPACE}" | md5sum | head -c16)"
375         rvm use "@${gemset}" --create \
376             || fatal 'rvm gemset setup'
377
378         rvm env
379     else
380         # When our "bundle install"s need to install new gems to
381         # satisfy dependencies, we want them to go where "gem install
382         # --user-install" would put them. (However, if the caller has
383         # already set GEM_HOME, we assume that's where dependencies
384         # should be installed, and we should leave it alone.)
385
386         if [ -z "$GEM_HOME" ]; then
387             user_gempath="$(gem env gempath)"
388             export GEM_HOME="${user_gempath%%:*}"
389         fi
390         PATH="$(gem env gemdir)/bin:$PATH"
391
392         # When we build and install our own gems, we install them in our
393         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
394         # PATH so integration tests prefer them over other versions that
395         # happen to be installed in $user_gempath, system dirs, etc.
396
397         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
398         PATH="$tmpdir_gem_home/bin:$PATH"
399         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
400
401         echo "Will install dependencies to $(gem env gemdir)"
402         echo "Will install arvados gems to $tmpdir_gem_home"
403         echo "Gem search path is GEM_PATH=$GEM_PATH"
404     fi
405 }
406
407 with_test_gemset() {
408     if [[ "$using_rvm" == true ]]; then
409         "$@"
410     else
411         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
412     fi
413 }
414
415 gem_uninstall_if_exists() {
416     if gem list "$1\$" | egrep '^\w'; then
417         gem uninstall --force --all --executables "$1"
418     fi
419 }
420
421 setup_virtualenv() {
422     local venvdest="$1"; shift
423     if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip" ]]; then
424         virtualenv --setuptools "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
425     fi
426     if [[ $("$venvdest/bin/python" --version 2>&1) =~ \ 3\.[012]\. ]]; then
427         # pip 8.0.0 dropped support for python 3.2, e.g., debian wheezy
428         "$venvdest/bin/pip" install 'setuptools>=18.5' 'pip>=7,<8'
429     else
430         "$venvdest/bin/pip" install 'setuptools>=18.5' 'pip>=7'
431     fi
432     # ubuntu1404 can't seem to install mock via tests_require, but it can do this.
433     "$venvdest/bin/pip" install 'mock>=1.0' 'pbr<1.7.0'
434 }
435
436 export PERLINSTALLBASE
437 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
438
439 export GOPATH
440 mkdir -p "$GOPATH/src/git.curoverse.com"
441 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
442     || fatal "symlink failed"
443
444 setup_virtualenv "$VENVDIR" --python python2.7
445 . "$VENVDIR/bin/activate"
446
447 # Needed for run_test_server.py which is used by certain (non-Python) tests.
448 pip freeze 2>/dev/null | egrep ^PyYAML= \
449     || pip install PyYAML >/dev/null \
450     || fatal "pip install PyYAML failed"
451
452 # Preinstall forked version of libcloud, because nodemanager "pip install"
453 # won't pick it up by default.
454 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
455     || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
456     || fatal "pip install apache-libcloud failed"
457
458 # Uninstall old llfuse (<1.0), because services/fuse "pip install"
459 # won't upgrade it by default.
460 if pip freeze | egrep '^llfuse==0'; then
461     yes | pip uninstall 'llfuse<1.0'
462 fi
463
464 # Deactivate Python 2 virtualenv
465 deactivate
466
467 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
468 # Otherwise, skip dependent tests.
469 PYTHON3=$(which python3)
470 if [ "0" = "$?" ]; then
471     setup_virtualenv "$VENV3DIR" --python python3
472 else
473     PYTHON3=
474     skip[services/dockercleaner]=1
475     cat >&2 <<EOF
476
477 Warning: python3 could not be found
478 services/dockercleaner install and tests will be skipped
479
480 EOF
481 fi
482
483 # Reactivate Python 2 virtualenv
484 . "$VENVDIR/bin/activate"
485
486 # Note: this must be the last time we change PATH, otherwise rvm will
487 # whine a lot.
488 setup_ruby_environment
489
490 echo "PATH is $PATH"
491
492 if ! which bundler >/dev/null
493 then
494     gem install --user-install bundler || fatal 'Could not install bundler'
495 fi
496
497 retry() {
498     remain="${repeat}"
499     while :
500     do
501         if ${@}; then
502             if [[ "$remain" -gt 1 ]]; then
503                 remain=$((${remain}-1))
504                 title "Repeating ${remain} more times"
505             else
506                 break
507             fi
508         elif [[ "$retry" == 1 ]]; then
509             read -p 'Try again? [Y/n] ' x
510             if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
511             then
512                 break
513             fi
514         else
515             break
516         fi
517     done
518 }
519
520 do_test() {
521     case "${1}" in
522         apps/workbench_units | apps/workbench_functional | apps/workbench_integration)
523             suite=apps/workbench
524             ;;
525         *)
526             suite="${1}"
527             ;;
528     esac
529     if [[ -z "${skip[$suite]}" && -z "${skip[$1]}" && \
530                 (-z "${only}" || "${only}" == "${suite}") ]]; then
531         retry do_test_once ${@}
532     else
533         title "Skipping ${1} tests"
534     fi
535 }
536
537 do_test_once() {
538     unset result
539
540     title "Running $1 tests"
541     timer_reset
542     if [[ "$2" == "go" ]]
543     then
544         covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
545         coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
546         # We do "go get -t" here to catch compilation errors
547         # before trying "go test". Otherwise, coverage-reporting
548         # mode makes Go show the wrong line numbers when reporting
549         # compilation errors.
550         go get -t "git.curoverse.com/arvados.git/$1" || return 1
551         cd "$WORKSPACE/$1" || return 1
552         gofmt -e -d . | egrep . && result=1
553         if [[ -n "${testargs[$1]}" ]]
554         then
555             # "go test -check.vv giturl" doesn't work, but this
556             # does:
557             cd "$WORKSPACE/$1" && go test ${short:+-short} ${testargs[$1]}
558         else
559             # The above form gets verbose even when testargs is
560             # empty, so use this form in such cases:
561             go test ${short:+-short} ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
562         fi
563         result=${result:-$?}
564         if [[ -f "$WORKSPACE/tmp/.$covername.tmp" ]]
565         then
566             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
567             rm "$WORKSPACE/tmp/.$covername.tmp"
568         fi
569     elif [[ "$2" == "pip" ]]
570     then
571         tries=0
572         cd "$WORKSPACE/$1" && while :
573         do
574             tries=$((${tries}+1))
575             # $3 can name a path directory for us to use, including trailing
576             # slash; e.g., the bin/ subdirectory of a virtualenv.
577             "${3}python" setup.py ${short:+--short-tests-only} test ${testargs[$1]}
578             result=$?
579             if [[ ${tries} < 3 && ${result} == 137 ]]
580             then
581                 printf '\n*****\n%s tests killed -- retrying\n*****\n\n' "$1"
582                 continue
583             else
584                 break
585             fi
586         done
587     elif [[ "$2" != "" ]]
588     then
589         "test_$2"
590     else
591         "test_$1"
592     fi
593     result=${result:-$?}
594     checkexit $result "$1 tests"
595     title "End of $1 tests (`timer`)"
596     return $result
597 }
598
599 do_install() {
600     if [[ -z "${skip_install}" && \
601                 (-z "${only_install}" || "${only_install}" == "${1}") ]]; then
602         retry do_install_once ${@}
603     else
604         title "Skipping $1 install"
605     fi
606 }
607
608 do_install_once() {
609     title "Running $1 install"
610     timer_reset
611     if [[ "$2" == "go" ]]
612     then
613         go get -t "git.curoverse.com/arvados.git/$1"
614     elif [[ "$2" == "pip" ]]
615     then
616         # $3 can name a path directory for us to use, including trailing
617         # slash; e.g., the bin/ subdirectory of a virtualenv.
618
619         # Need to change to a different directory after creating
620         # the source dist package to avoid a pip bug.
621         # see https://arvados.org/issues/5766 for details.
622
623         # Also need to install twice, because if it believes the package is
624         # already installed, pip it won't install it.  So the first "pip
625         # install" ensures that the dependencies are met, the second "pip
626         # install" ensures that we've actually installed the local package
627         # we just built.
628         cd "$WORKSPACE/$1" \
629             && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
630             && cd "$WORKSPACE" \
631             && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
632             && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
633     elif [[ "$2" != "" ]]
634     then
635         "install_$2"
636     else
637         "install_$1"
638     fi
639     result=$?
640     checkexit $result "$1 install"
641     title "End of $1 install (`timer`)"
642     return $result
643 }
644
645 bundle_install_trylocal() {
646     (
647         set -e
648         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
649         if ! bundle install --local --no-deployment; then
650             echo "(Running bundle install again, without --local.)"
651             bundle install --no-deployment
652         fi
653         bundle package --all
654     )
655 }
656
657 install_doc() {
658     cd "$WORKSPACE/doc" \
659         && bundle_install_trylocal \
660         && rm -rf .site
661 }
662 do_install doc
663
664 install_gem() {
665     gemname=$1
666     srcpath=$2
667     with_test_gemset gem_uninstall_if_exists "$gemname" \
668         && cd "$WORKSPACE/$srcpath" \
669         && bundle_install_trylocal \
670         && gem build "$gemname.gemspec" \
671         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
672 }
673
674 install_ruby_sdk() {
675     install_gem arvados sdk/ruby
676 }
677 do_install sdk/ruby ruby_sdk
678
679 install_perl_sdk() {
680     cd "$WORKSPACE/sdk/perl" \
681         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
682         && make install INSTALLDIRS=perl
683 }
684 do_install sdk/perl perl_sdk
685
686 install_cli() {
687     install_gem arvados-cli sdk/cli
688 }
689 do_install sdk/cli cli
690
691 install_login-sync() {
692     install_gem arvados-login-sync services/login-sync
693 }
694 do_install services/login-sync login-sync
695
696 # Install the Python SDK early. Various other test suites (like
697 # keepproxy) bring up run_test_server.py, which imports the arvados
698 # module. We can't actually *test* the Python SDK yet though, because
699 # its own test suite brings up some of those other programs (like
700 # keepproxy).
701 declare -a pythonstuff
702 pythonstuff=(
703     sdk/pam
704     sdk/python
705     sdk/cwl
706     services/fuse
707     services/nodemanager
708     tools/crunchstat-summary
709     )
710 for p in "${pythonstuff[@]}"
711 do
712     do_install "$p" pip
713 done
714 if [ -n "$PYTHON3" ]; then
715     do_install services/dockercleaner pip "$VENV3DIR/bin/"
716 fi
717
718 install_apiserver() {
719     cd "$WORKSPACE/services/api" \
720         && RAILS_ENV=test bundle_install_trylocal
721
722     rm -f config/environments/test.rb
723     cp config/environments/test.rb.example config/environments/test.rb
724
725     if [ -n "$CONFIGSRC" ]
726     then
727         for f in database.yml application.yml
728         do
729             cp "$CONFIGSRC/$f" config/ || fatal "$f"
730         done
731     fi
732
733     # Fill in a random secret_token and blob_signing_key for testing
734     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
735     BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
736
737     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
738     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
739
740     # Set up empty git repo (for git tests)
741     GITDIR=$(mktemp -d)
742     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
743
744     rm -rf $GITDIR
745     mkdir -p $GITDIR/test
746     cd $GITDIR/test \
747         && git init \
748         && git config user.email "jenkins@ci.curoverse.com" \
749         && git config user.name "Jenkins, CI" \
750         && touch tmp \
751         && git add tmp \
752         && git commit -m 'initial commit'
753
754     # Clear out any lingering postgresql connections to the test
755     # database, so that we can drop it. This assumes the current user
756     # is a postgresql superuser.
757     cd "$WORKSPACE/services/api" \
758         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
759         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
760
761     cd "$WORKSPACE/services/api" \
762         && RAILS_ENV=test bundle exec rake db:drop \
763         && RAILS_ENV=test bundle exec rake db:setup \
764         && RAILS_ENV=test bundle exec rake db:fixtures:load
765 }
766 do_install services/api apiserver
767
768 declare -a gostuff
769 gostuff=(
770     sdk/go/arvados
771     sdk/go/arvadosclient
772     sdk/go/blockdigest
773     sdk/go/httpserver
774     sdk/go/manifest
775     sdk/go/streamer
776     sdk/go/crunchrunner
777     sdk/go/stats
778     lib/crunchstat
779     services/arv-git-httpd
780     services/crunchstat
781     services/keep-web
782     services/keepstore
783     sdk/go/keepclient
784     services/keep-balance
785     services/keepproxy
786     services/crunch-dispatch-local
787     services/crunch-dispatch-slurm
788     services/crunch-run
789     services/ws
790     tools/keep-block-check
791     tools/keep-exercise
792     tools/keep-rsync
793     )
794 for g in "${gostuff[@]}"
795 do
796     do_install "$g" go
797 done
798
799 install_workbench() {
800     cd "$WORKSPACE/apps/workbench" \
801         && mkdir -p tmp/cache \
802         && RAILS_ENV=test bundle_install_trylocal
803 }
804 do_install apps/workbench workbench
805
806 test_doclinkchecker() {
807     (
808         set -e
809         cd "$WORKSPACE/doc"
810         ARVADOS_API_HOST=qr1hi.arvadosapi.com
811         # Make sure python-epydoc is installed or the next line won't
812         # do much good!
813         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
814     )
815 }
816 do_test doc doclinkchecker
817
818 stop_services
819
820 test_apiserver() {
821     rm -f "$WORKSPACE/services/api/git-commit.version"
822     cd "$WORKSPACE/services/api" \
823         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
824 }
825 do_test services/api apiserver
826
827 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
828 # because we don't need to start up the api server for subsequent tests.
829 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
830   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
831   exit_cleanly
832 fi
833
834 start_api
835
836 test_ruby_sdk() {
837     cd "$WORKSPACE/sdk/ruby" \
838         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
839 }
840 do_test sdk/ruby ruby_sdk
841
842 test_cli() {
843     cd "$WORKSPACE/sdk/cli" \
844         && mkdir -p /tmp/keep \
845         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
846 }
847 do_test sdk/cli cli
848
849 test_login-sync() {
850     cd "$WORKSPACE/services/login-sync" \
851         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
852 }
853 do_test services/login-sync login-sync
854
855 for p in "${pythonstuff[@]}"
856 do
857     do_test "$p" pip
858 done
859 do_test services/dockercleaner pip "$VENV3DIR/bin/"
860
861 for g in "${gostuff[@]}"
862 do
863     do_test "$g" go
864 done
865
866 test_workbench_units() {
867     start_nginx_proxy_services \
868         && cd "$WORKSPACE/apps/workbench" \
869         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:units TESTOPTS=-v ${testargs[apps/workbench]}
870 }
871 do_test apps/workbench_units workbench_units
872
873 test_workbench_functionals() {
874     start_nginx_proxy_services \
875         && cd "$WORKSPACE/apps/workbench" \
876         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:functionals TESTOPTS=-v ${testargs[apps/workbench]}
877 }
878 do_test apps/workbench_functionals workbench_functionals
879
880 test_workbench_integration() {
881     start_nginx_proxy_services \
882         && cd "$WORKSPACE/apps/workbench" \
883         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:integration TESTOPTS=-v ${testargs[apps/workbench]}
884 }
885 do_test apps/workbench_integration workbench_integration
886
887
888 test_workbench_benchmark() {
889     start_nginx_proxy_services \
890         && cd "$WORKSPACE/apps/workbench" \
891         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
892 }
893 do_test apps/workbench_benchmark workbench_benchmark
894
895 test_workbench_profile() {
896     start_nginx_proxy_services \
897         && cd "$WORKSPACE/apps/workbench" \
898         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:profile ${testargs[apps/workbench_profile]}
899 }
900 do_test apps/workbench_profile workbench_profile
901
902 exit_cleanly